unit uEdit;
{
UnicodeΉ̓{bNXB
WindowsRichEditRg[𗘗pB
eLXg̏Cɂ͔ΉB
}

interface
uses
	Classes,
	Controls,
	Grids,
	Messages,
	StdCtrls,
	Windows,
	Graphics; //Windows艺łȂTBitmapŕssoꍇB

type
	T_MyBkValue = record
		SelStart  : Integer;
		SelLength : Integer;
		Text      : WideString;
		Tabs      : array of Longint;
		Color     : TColor;
		Rect      : TRect;
		AutoFont  : Boolean;
	end;

{ TMyCustomEditControl }
	TMyCustomEditControl = class(TObject)
	private
		{ Private 錾 }
		FiLeft           : Integer;
		FiTop            : Integer;
		FiWidth          : Integer;
		FiHeight         : Integer;
		FhEditHandle     : HWND;
		FParent          : TWinControl;
		FFont            : TFont;
		FclTextColor     : TColor;
		FclBkColor       : TColor;
		FTabs            : array of Longint;
		FBkValue         : T_MyBkValue;
		FbReadOnly       : Boolean;
		FbHideSelection  : Boolean;
		FbFindForward    : Boolean;
		FbFindIgnoreCase : Boolean;
		FbFindWholeWord  : Boolean;

		procedure FSetLeft(iLeft: Integer);
		procedure FSetTop(iTop: Integer);
		procedure FSetWidth(iWidth: Integer);
		procedure FSetHeight(iHeight: Integer);
		function  FGetClientRect: TRect;
		function  FGetBoundsRect: TRect;

		procedure FSetTabStops;                //zFTabs̓eŃ^uZbg
		procedure FSetTabs(iTabStop: Longint); //^u̕iTabStopɂ
		function  FGetTabs: Longint;

		function  FGetModified: Boolean;
		procedure FSetModified(Value: Boolean);
		function  FGetCanUndo: Boolean;
		function  FGetCanRedo: Boolean;
		procedure FSetFont(Value: TFont);
		procedure FFontChange(Sender: TObject);
		procedure FSetColor(Value: TColor);
		function  FGetSelStart: Integer;
		procedure FSetSelStart(iIndex: Integer);
		function  FGetSelLength: Integer;
		procedure FSetSelLength(iCount: Integer);
		function  FGetText: WideString;
		procedure FSetText(sText: WideString);
		function  FGetSelected: Boolean;
		function  FGetSelText: WideString;
		procedure FSetSelText(sStr: WideString);
		function  FGetCaretIndex: Integer; //J[\ʒu̕0x[X̃CfbNX
		procedure FSetCaretIndex(iIndex: Integer);
		procedure FSetReadOnly(bReadOnly: Boolean);
		procedure FSetHideSelection(bHide: Boolean);
		procedure FSetAutoFont(Value: Boolean); virtual;
	protected
		procedure CreateWnd(iStyle: Longint); virtual;
		procedure RecreateWnd(iStyle: Longint); virtual;
		procedure BackupValue; virtual;
		procedure RestoreValue; virtual;
		function  GetAutoFont: Boolean; virtual;
		procedure SetAutoFont(Value: Boolean); virtual;
		procedure SetTabs(Tabs: array of Longint); overload;

		property Left           : Integer    read FiLeft           write FSetLeft;
		property Top            : Integer    read FiTop            write FSetTop;
		property Width          : Integer    read FiWidth          write FSetWidth;
		property Height         : Integer    read FiHeight         write FSetHeight;
		property Text           : WideString read FGetText         write FSetText;
		property Font           : TFont      read FFont            write FSetFont;
		property Tabs           : Longint    read FGetTabs         write FSetTabs          default 0;
		property Color          : TColor     read FclBkColor       write FSetColor         default clWindow;
		property AutoFont       : Boolean    read GetAutoFont      write SetAutoFont       default True;
		property HideSelection  : Boolean    read FbHideSelection  write FSetHideSelection default True;
		property FindForward    : Boolean    read FbFindForward    write FbFindForward     default True;  //
		property FindIgnoreCase : Boolean    read FbFindIgnoreCase write FbFindIgnoreCase  default True;  //啶ʂȂ
		property FindWholeWord  : Boolean    read FbFindWholeWord  write FbFindWholeWord   default False; //Pꌟł͂Ȃ
	public
		{ Public 錾 }
		constructor Create(winParent: TWinControl); overload;
		constructor Create(winParent: TWinControl; iStyle: DWORD); overload;
		destructor  Destroy; override;

		procedure Show;
		procedure Hide;
		function  Focused: Boolean;
		procedure SetFocus;
		procedure SetBounds(iLeft, iTop, iWidth, iHeight: Integer); overload;
		procedure SetBounds(rcRect: TRect); overload;
		procedure ScrollCaret;
		procedure Clear;
		procedure ClearUndo;
		procedure Undo;
		procedure Redo;
		procedure CutToClipboard;
		procedure CopyToClipboard;
		procedure PasteFromClipboard;
		procedure ClearSelection;
		procedure SelectAll;
		procedure Insert(sText: WideString);
		function  CanPaste: Boolean;
		function  Empty: Boolean; virtual;
		function  Length: Integer;
		function  StrCopy: WideString; overload; virtual;
		function  StrCopy(iCount: Integer): WideString; overload; virtual;
		function  StrCopy(iIndex, iCount: Integer): WideString; overload; virtual;
		function  FindText(sStr: WideString): Integer;
		procedure Find; overload;
		procedure Find(sStr: WideString); overload;
		procedure SaveToFile(sFile: WideString);
		procedure LoadFromFile(sFile: WideString);

		property Handle:     HWND       read FhEditHandle;
		property ClientRect: TRect      read FGetClientRect;
		property BoundsRect: TRect      read FGetBoundsRect;
		property CaretIndex: Integer    read FGetCaretIndex write FSetCaretIndex;
		property CanUndo:    Boolean    read FGetCanUndo;
		property CanRedo:    Boolean    read FGetCanRedo;
		property Modified:   Boolean    read FGetModified   write FSetModified;
		property Selected:   Boolean    read FGetSelected;
		property SelStart:   Integer    read FGetSelStart   write FSetSelStart;
		property SelLength:  Integer    read FGetSelLength  write FSetSelLength;
		property SelText:    WideString read FGetSelText    write FSetSelText;
		property ReadOnly:   Boolean    read FbReadOnly     write FSetReadOnly;
	end;

{TMyEditControl}
	TMyEditControl = class(TMyCustomEditControl)
//	public
	published
		property Left;
		property Top;
		property Width;
		property Height;
		property Color;
		property Text;
		property Tabs;
		property Font;
		property AutoFont;
		property HideSelection;
		property FindForward;
		property FindIgnoreCase;
		property FindWholeWord;
	end;


{TMyMemoControl}
	TMyMemoControl = class(TMyCustomEditControl)
	private
		FParent      : TWinControl;
		FScrollBars  : TScrollStyle;
		FbWordWrap   : Boolean;
		FbLineHeight : Boolean;

		function  FGetCount: Integer;
		function  FGetCurrentLine: Integer;
		function  FGetColumn: Integer;
		function  FGetTopIndex: Integer;
		procedure FSetTopIndex(iIndex: Integer);
		procedure FSetLineHeight;
	protected
		procedure CreateWnd(iStyle: Longint); override;
		procedure RestoreValue; override;

		procedure SetScrollBars(Value: TScrollStyle);
		procedure SetWordWrap(Value: Boolean);
		procedure SetLineHeight(Value: Boolean);
	public
		{ Public 錾 }
		constructor Create(winParent: TWinControl); overload;
		constructor Create(winParent: TWinControl; iStyle: DWORD); overload;
		function  GetLine(iIndex: Integer): WideString;	//0x[X
		function  Empty: Boolean; override;
		function  StrCopy(iCount: Integer): WideString; overload; override;
		function  StrCopy(iLine, iIndex, iCount: Integer): WideString; overload;

		property Count:       Integer read FGetCount;
		property CurrentLine: Integer read FGetCurrentLine; //0x[X
		property Column:      Integer read FGetColumn;      //0x[X
		property TopIndex:    Integer read FGetTopIndex write FSetTopIndex;
	published
		property Left;
		property Top;
		property Width;
		property Height;
		property Text;
		property Tabs;
		property Font;
		property AutoFont;
		property Color;
		property HideSelection;
		property FindForward;
		property FindIgnoreCase;
		property FindWholeWord;
		property ScrollBars: TScrollStyle read FScrollBars  write SetScrollBars default ssBoth;
		property LineHeight: Boolean      read FbLineHeight write SetLineHeight default False; //sԂJ
		property WordWrap:   Boolean      read FbWordWrap   write SetWordWrap   default False; //܂Ԃ
	end;

const
	GT_SELECTION = 2;
	GT_RAWTEXT	 = 4;

const
	IMF_AUTOKEYBOARD        = $00000001;
	IMF_FORCENONE           = $00000001;
	IMF_AUTOFONT            = $00000002;
	IMF_FORCEENABLE         = $00000002;
	IMF_IMECANCELCOMPLETE   = $00000004;
	IMF_FORCEDISABLE        = $00000004;
	IMF_CLOSESTATUSWINDOW   = $00000008;
	IMF_IMEALWAYSSENDNOTIFY = $00000008;
	IMF_AUTOFONTSIZEADJUST  = $00000010;
	IMF_UIFONTS             = $00000020;
	IMF_VERTICAL            = $00000020;
	IMF_FORCEACTIVE         = $00000040;
	IMF_DUALFONT            = $00000080;
	IMF_FORCEINACTIVE       = $00000080;
	IMF_FORCEREMEMBER       = $00000100;
	IMF_MULTIPLEEDIT        = $00000400;


implementation
uses
//	myDebug,
	CommDlg,
	Forms,
	RichEdit,
	TypInfo,
	SysUtils,
	uCode;


var
	lhRichEditModule: THandle;

const
	lcsMODULENAME = 'Riched20.dll';

// ėp֐ --------------------------------------------------------------------
//Unicode
const
	CP_SHIFTJIS = 932;
	CP_JIS      = 50220; //pJi͑SpɕϊB
//	CP_JIS      = 50221; //pJiOKB
//	CP_JIS      = 50222; //SI/SO
//	CP_EUC      = 51932; //MultiByteToWideCharWideCharToMultiByteł̓G[ɂȂB
	CP_EUC      = 20932; //ςɂgOKB

const
	WC_NO_BEST_FIT_CHARS = $00000400;

function gfnbIsUnicode(sSrc: WideString): Boolean;
//sSrcɃEEĝ悤UnicodeTrueԂ
var
	lb_Bool: LongBool;
begin
	WideCharToMultiByte(CP_ACP, WC_NO_BEST_FIT_CHARS, PWideChar(sSrc), -1, nil, 0, nil, @lb_Bool);
	Result := lb_Bool;
end;

//WideStringAnsiString
function gfnsWideToAnsi(sSrc: WideString): AnsiString;
//ƂAnsiStringɕϊB
//)uvuv݂ȊŁB
const
	lcs_DEF = '';
var
	li_Len:  Integer;
	lp_Buff: PAnsiChar;
begin
	//WC_COMPOSITECHECK
	li_Len  := WideCharToMultiByte(CP_ACP, WC_COMPOSITECHECK{ or WC_SEPCHARS}, PWideChar(sSrc), -1, nil, 0, nil, nil);
	Inc(li_Len);
	lp_Buff := AllocMem(li_Len);
	try
		WideCharToMultiByte(CP_ACP, WC_COMPOSITECHECK{ or WC_SEPCHARS}, PWideChar(sSrc), -1, lp_Buff, li_Len, nil, nil);
		Result := AnsiString(lp_Buff);
	finally
		FreeMem(lp_Buff);
	end;
end;

//UTF-16LEUTF-8
function gfnsWideToUTF8(sSrc: WideString): UTF8String;
{
WideStringUTF-8ɃGR[hĕԂB
TQ[gyAɂΉB
UTF8Encode̕B
}
var
	li_Len:  Integer;
	lp_Buff: PAnsiChar;
begin
	li_Len  := WideCharToMultiByte(CP_UTF8, 0, PWideChar(sSrc), -1, nil, 0, nil, nil);
	lp_Buff := AllocMem(li_Len + 1);
	try
		WideCharToMultiByte(CP_UTF8, 0, PWideChar(sSrc), -1, lp_Buff, li_Len +1, nil, nil);
		Result := UTF8String(lp_Buff);
	finally
		FreeMem(lp_Buff);
	end;
end;
function gfnsUTF8ToWide(sSrc: UTF8String): WideString;
{
UTF-8ŃGR[hĂ镶WideStringɂĕԂB
TQ[gyAɂΉB
UTF8Decode̕B
}
var
	li_Len:  Integer;
	lp_Buff: PWideChar;
begin
	li_Len  := MultiByteToWideChar(CP_UTF8, 0, PAnsiChar(sSrc), -1, nil, 0);
	lp_Buff := AllocMem((li_Len + 1) * 2);
	try
		MultiByteToWideChar(CP_UTF8, 0, PAnsiChar(sSrc), -1, lp_Buff, li_Len);
		Result := WideString(lp_Buff);
	finally
		FreeMem(lp_Buff);
	end;
end;

//UTF-16LEUTF-7
function gfnsWideToUtf7(sSrc: WideString): AnsiString;
//WideStringUTF-7ɃGR[hĕԂ
var
	li_Len:  Integer;
	lp_Buff: PAnsiChar;
begin
	//WC_COMPOSITECHECKNG
	li_Len  := WideCharToMultiByte(CP_UTF7, 0, PWideChar(sSrc), -1, nil, 0, nil, nil);
	lp_Buff := AllocMem(li_Len + 1);
	try
		WideCharToMultiByte(CP_UTF7, 0, PWideChar(sSrc), -1, lp_Buff, li_Len, nil, nil);
		Result := AnsiString(lp_Buff);
	finally
		FreeMem(lp_Buff);
	end;
end;
function gfnsUtf7ToWide(sSrc: AnsiString): WideString;
//UTF-7ŃGR[hĂ镶WideStringɂĕԂ
var
	li_Len:  Integer;
	lp_Buff: PWideChar;
begin
	li_Len  := MultiByteToWideChar(CP_UTF7, 0, PAnsiChar(sSrc), -1, nil, 0);
	lp_Buff := AllocMem((li_Len + 1) * 2);
	try
		MultiByteToWideChar(CP_UTF7, 0, PAnsiChar(sSrc), -1, lp_Buff, li_Len);
		Result := WideString(lp_Buff);
	finally
		FreeMem(lp_Buff);
	end;
end;

//JISWideString
function gfnsJisToWide(sSrc: AnsiString): WideString;
var
	li_Len:  Integer;
	lp_Buff: PWideChar;
begin
	li_Len  := MultiByteToWideChar(CP_JIS, 0, PAnsiChar(sSrc), -1, nil, 0);
	lp_Buff := AllocMem((li_Len + 1) * 2);
	try
		MultiByteToWideChar(CP_JIS, 0, PAnsiChar(sSrc), -1, lp_Buff, li_Len);
		Result := WideString(lp_Buff);
	finally
		FreeMem(lp_Buff);
	end;
end;
function gfnsWideToJis(sSrc: WideString): AnsiString;
var
	li_Src  : Integer;
	li_Len  : Integer;
	lp_Buff : PAnsiChar;
begin
	//http://www.gesource.jp/weblog/?p=738
	//http://ht-deko.minim.ne.jp/ft0909.html#090927
	li_Src  := Length(sSrc);
	li_Len  := (li_Src * 5) + 4 - (li_Src div 2);
	lp_Buff := AllocMem(li_Len + 1);
	try
		WideCharToMultiByte(CP_JIS, 0, PWideChar(sSrc), -1, lp_Buff, li_Len +1, nil, nil);
		Result := AnsiString(lp_Buff);
	finally
		FreeMem(lp_Buff);
	end;
end;

//EUCWideString
function gfnsEucToWide(sSrc: AnsiString): WideString;
var
	li_Len:  Integer;
	lp_Buff: PWideChar;
begin
	li_Len  := MultiByteToWideChar(CP_EUC, 0, PAnsiChar(sSrc), -1, nil, 0);
	lp_Buff := AllocMem((li_Len + 1) * 2);
	try
		MultiByteToWideChar(CP_EUC, 0, PAnsiChar(sSrc), -1, lp_Buff, li_Len);
		Result := WideString(lp_Buff);
	finally
		FreeMem(lp_Buff);
	end;
end;
function gfnsWideToEuc(sSrc: WideString): AnsiString;
var
	li_Len:  Integer;
	lp_Buff: PAnsiChar;
begin
	li_Len  := WideCharToMultiByte(CP_EUC, WC_COMPOSITECHECK, PWideChar(sSrc), -1, nil, 0, nil, nil);
	lp_Buff := AllocMem(li_Len + 1);
	try
		WideCharToMultiByte(CP_EUC, WC_COMPOSITECHECK, PWideChar(sSrc), -1, lp_Buff, li_Len +1, nil, nil);
		Result := AnsiString(lp_Buff);
	finally
		FreeMem(lp_Buff);
	end;
end;


//------------------------------------------------------------------------------
//Nbv{[h
function gfnsStrFromClipboard: WideString;
//Nbv{[h̕擾ĕԂ
var
	li_Format: array[0..1] of Integer;
	li_Text: Integer;
	lh_Clip, lh_Data: THandle;
	lp_Clip, lp_Data: Pointer;
begin
	Result := '';
	li_Format[0] := CF_UNICODETEXT;
	li_Format[1] := CF_TEXT;
	li_Text := GetPriorityClipboardFormat(li_Format, 2);
	if (li_Text > 0) then begin
		if (OpenClipboard(Application.Handle)) then begin
			lh_Clip := GetClipboardData(li_Text);
			if (lh_Clip <> 0) then begin
				lh_Data := 0;
				if (GlobalFlags(lh_Clip) <> GMEM_INVALID_HANDLE) then begin
					try
						if (li_Text = CF_UNICODETEXT)  then begin
							//UnicodeD
							lh_Data := GlobalAlloc(GHND or GMEM_SHARE, GlobalSize(lh_Clip));
							lp_Clip := GlobalLock(lh_Clip);
							lp_Data := GlobalLock(lh_Data);
							lstrcpyW(lp_Data, lp_Clip);
							Result := WideString(PWideChar(lp_Data));
							GlobalUnlock(lh_Data);
							GlobalFree(lh_Data);
							GlobalUnlock(lh_Clip);	//GlobalFree͂Ă͂Ȃ
						end else if (li_Text = CF_TEXT) then begin
							lh_Data := GlobalAlloc(GHND or GMEM_SHARE, GlobalSize(lh_Clip));
							lp_Clip := GlobalLock(lh_Clip);
							lp_Data := GlobalLock(lh_Data);
							lstrcpy(lp_Data, lp_Clip);
							Result := AnsiString(PAnsiChar(lp_Data));
							GlobalUnlock(lh_Data);
							GlobalFree(lh_Data);
							GlobalUnlock(lh_Clip);	//GlobalFree͂Ă͂Ȃ
						end;
					finally
						if (lh_Data <> 0) then GlobalUnlock(lh_Data);
						CloseClipboard;
					end;
				end;
			end;
		end;
	end;
end;

procedure gpcStrToClipboard(sText: WideString);
//Nbv{[h֕Zbg
//UnicodeƂăZbgƓɁiUnicodełȂjv[eLXgƂĂZbg
var
	li_WLen, li_Len: Integer;
	ls_Text: AnsiString;
	lh_Mem:  THandle;
	lp_Data: Pointer;
begin
	li_WLen := (Length(sText) + 1) * 2;
	ls_Text := gfnsWideToAnsi(sText);
	li_Len  := Length(ls_Text) + 1;
	if (sText <> '') then begin
		if (OpenClipboard(Application.Handle)) then begin
			try
				EmptyClipboard;
				//CF_UNICODETEXT
				lh_Mem  := GlobalAlloc(GHND or GMEM_SHARE, li_WLen);
				lp_Data := GlobalLock(lh_Mem);
				lstrcpyW(lp_Data, PWideChar(sText));
				GlobalUnlock(lh_Mem);
				SetClipboardData(CF_UNICODETEXT, lh_Mem);
				//CF_TEXT
				lh_Mem  := GlobalAlloc(GHND or GMEM_SHARE, li_Len);
				lp_Data := GlobalLock(lh_Mem);
				lstrcpy(lp_Data, PAnsiChar(ls_Text));
				GlobalUnlock(lh_Mem);
				SetClipboardData(CF_TEXT, lh_Mem);
			finally
				CloseClipboard;
			end;
		end;
	end;
end;

// l ------------------------------------------------------------------------
function gfniNumLimit(iNum: Integer; iMin, iMax: Integer): Integer;
begin
	if (iMin = iMax) then begin
		Result := iMin;
	end else begin
		if (iNum < iMin) then begin
			Result := iMin;
		end else if (iNum > iMax) then begin
			Result := iMax;
		end else begin
			Result := iNum;
		end;
	end;
end;

// Unicodeǂݏ -------------------------------------------------------------
procedure gpcFileWriteText(sFile, sText: WideString);
//UnicodeΉ̃t@C݁B
//UnicodeȕBOMUTF-8ŁAłȂShift-JISŏށB
var
	li_Count   : DWORD;
	lb_Unicode : Boolean;
	ls_Str     : AnsiString;
	lh_Handle  : THandle;
begin
	if (gfnbIsUnicode(sText)) then
	begin
		//ʂsTextUnicodeUtf-8ŏ
		lb_Unicode := True;
//		ls_Str := Utf8Encode(sText);  //D6Utf8Encode̓TQ[gyAɔΉ
		ls_Str := gfnsWideToUtf8(sText);
	end else
	begin
		//Shift-JIS
		lb_Unicode := False;
		ls_Str := gfnsWideToAnsi(sText);
	end;

	lh_Handle := CreateFileW(
			PWideChar(sFile),      //t@C
			GENERIC_WRITE,         //ANZX[h
			0,                     //L[h
			nil,                   //ZLeB
			CREATE_ALWAYS,         //쐬@
			FILE_ATTRIBUTE_NORMAL, //t@C
			0                      //ev[g
	);
	try
		if (lb_Unicode) then
		begin
			WriteFile(lh_Handle, #$EF#$BB#$BF, 3, li_Count, nil); //BOMtB
		end;
		WriteFile(lh_Handle, PAnsiChar(ls_Str)^, Length(ls_Str), li_Count, nil);
	finally
		CloseHandle(lh_Handle);
	end;
end;

function gfniFileSizeGet(sFile: WideString): Int64;
//sWFilẽTCYBytePʂŕԂB
var
	lh_File: Cardinal;
	lr_Info: TWin32FindDataW;
begin
	Result := 0;
	lh_File := FindFirstFileW(PWideChar(sFile), lr_Info);
	try
		if (lh_File <> INVALID_HANDLE_VALUE) then
		begin
			repeat
				if not(BOOL(lr_Info.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY)) then
				begin
					Result := lr_Info.nFileSizeHigh * (Int64(MAXDWORD) + 1) + lr_Info.nFileSizeLow;
					Break;
				end;
			until not(FindNextFileW(lh_File, lr_Info));
		end;
	finally
		Windows.FindClose(lh_File);
	end;
end;

function gfnsFileReadText(sFile: WideString): WideString;
//UnicodeΉeLXgt@Cǂݍ݁B
//R[h͎
//http://www.xmleditor.jp/blog/archives/40
var
	lh_Handle : THandle;
	lp_Buff   : PAnsiChar;
	li_Count  : DWORD;
	li_Size   : DWORD;
	li_Len    : Integer;
	lp_Endian : PWideChar;
begin
	li_Size := gfniFileSizeGet(sFile);
	lp_Buff := AllocMem(li_Size +2);	//WideString(lp_Buff)ƂĂȂ悤+2
	try
		lh_Handle := CreateFileW(
			PWideChar(sFile),				//t@C
			GENERIC_READ,					  //ANZX[h
			FILE_SHARE_READ,				//L[h
			nil,										//ZLeB
			OPEN_EXISTING,					//쐬@
			FILE_ATTRIBUTE_NORMAL,	//t@C
			0                   	  //ev[g
		);
		ReadFile(lh_Handle, lp_Buff^, li_Size, li_Count, nil);
		CloseHandle(lh_Handle);

		if (li_Count <= 0) then
		begin
			Result := '';
		end else
		begin
			case gfniCodePageGet(lp_Buff, li_Count) of
				65001 //UTF-8
				:begin
					Result := gfnsUtf8ToWide(Utf8String(PAnsiChar(lp_Buff)));
				end;
				1200 //UTF-16 LE (gGfBA)
				:begin
					Result := WideString(PWideChar(lp_Buff));
				end;
				1201 //UTF-16 BE (rbOGfBA)
				:begin
					Result := WideString(PWideChar(lp_Buff));
					//rbOGfBAȂ̂ŃGfBAւ
					li_Len    := LCMapStringW(GetUserDefaultLCID(), LCMAP_BYTEREV, PWideChar(Result), -1, nil, 0);
					lp_Endian := AllocMem((li_Len +1) * 2);
					try
						LCMapStringW(GetUserDefaultLCID(), LCMAP_BYTEREV, PWideChar(Result), -1, lp_Endian, li_Len);
						Result := WideString(lp_Endian);
					finally
						FreeMem(lp_Endian);
					end;
				end;
				65000 //UTF-7
				:begin
					Result := gfnsUtf7ToWide(AnsiString(lp_Buff));
				end;
				50220, //{ (JIS) iso-2022-jp
				50221, //{ (JIS 1 oCg J^Ji) csISO2022JP
				50222, //{ (JIS 1 oCg J^Ji - SO/SI) iso-2022-jp
				50225, //؍ (ISO) iso-2022-kr
				50227  //ȑ̎ (ISO-2022) x-cp50227
				:begin
					Result := gfnsJisToWide(AnsiString(lp_Buff));
				end;
				20932, //{ (JIS 0208-1990  0212-1990) EUC-JP
				51932, //{ (EUC) euc-jp
				51936, //ȑ̎ (EUC) EUC-CN
				51949  //؍ (EUC) euc-kr
				:begin
					Result := gfnsEucToWide(AnsiString(lp_Buff));
				end;
				else
				begin
					//̑Shift-JISƂď
					Result := AnsiString(lp_Buff);
				end;
			end;

			//BOMΎ菜
			if (PAnsiChar(PWideChar(Result))[0] = #$FF)
			or (PAnsiChar(PWideChar(Result))[1] = #$FE)
			then
			begin
				Result := Copy(Result, 2, MAXINT);
			end;
		end;
	finally
		FreeMem(lp_Buff);
	end;
end;


//==============================================================================
{ TMyCustomEditControl }
procedure TMyCustomEditControl.CreateWnd(iStyle: Longint);
begin
	Create(FParent, iStyle);
end;

procedure TMyCustomEditControl.RecreateWnd(iStyle: Longint);
begin
	BackupValue;
	DestroyWindow(Handle); //Uj
	CreateWnd(iStyle);     //č쐬
	RestoreValue;
end;

//ǂݒꍇɃJ[\ʒuIԂޔ
procedure TMyCustomEditControl.BackupValue;
var
	i: Integer;
begin
	FBkValue.Text      := Text;          //eLXgޔ
	FBkValue.SelStart  := CaretIndex;    //J[\ʒuޔ
	FBkValue.SelLength := SelLength;     //IĂ͈͂ޔ
	FBkValue.Rect      := BoundsRect;    //Rectޔ
	FBkValue.AutoFont  := GetAutoFont;   //I[gtHg̒lޔ
	SetLength(FBkValue.Tabs, High(FTabs)+1);
	for i := 0 to High(FTabs) do
	begin
		FBkValue.Tabs[i] := FTabs[i];
	end;
end;

//őޔݒl߂
procedure TMyCustomEditControl.RestoreValue;
var
	i: Integer;
begin
	SetBounds(FBkValue.Rect); //Rect𕜌
	SetLength(FTabs, High(FBkValue.Tabs)+1);
	for i := 0 to High(FBkValue.Tabs) do
	begin
		FTabs[i] := FBkValue.Tabs[i];
	end;
	FSetTabStops;                      //^u̕
	//SetAutoFontNG
	FSetAutoFont(FBkValue.AutoFont);   //I[gtHg̐ݒ𕜌
	Text := FBkValue.Text;             //eLXg𕜌
	CaretIndex := FBkValue.SelStart;   //J[\ʒu𕜌
	if (FBkValue.SelLength > 0) then
	begin
		SelLength := FBkValue.SelLength; //IĂ͈͂𕜌
	end;
	ScrollCaret;                       //J[\܂ŃXN[
	SetFocus;
end;

constructor TMyCustomEditControl.Create(winParent: TWinControl);
begin
	Create(winParent, ES_AUTOHSCROLL);
end;

constructor TMyCustomEditControl.Create(winParent: TWinControl; iStyle: DWORD);
begin
	if (lhRichEditModule = 0) then
	begin
		lhRichEditModule := LoadLibrary(lcsMODULENAME);
		if (lhRichEditModule <= HINSTANCE_ERROR) then
		begin
			lhRichEditModule := 0;
		end;
	end;

	FbReadOnly       := False;
	FbHideSelection  := True;
	FbFindForward    := True;  //
	FbFindIgnoreCase := True;  //啶ʂȂ
	FbFindWholeWord  := False; //Pꌟł͂Ȃ
	FclTextColor     := clWindowText;
	FclBkColor       := clWindow;
	SetLength(FTabs, 1);
	FTabs[0] := 0;

	FParent := winParent;
	with FParent do
	begin
		FiLeft   := 0;
		FiTop    := 0;
		FiWidth  := ClientWidth;
		FiHeight := ClientHeight;

		//GfBbg{bNX
		FhEditHandle := CreateWindowW(
			RICHEDIT_CLASSW,
			nil,
			WS_CHILD
			or WS_VISIBLE
			or iStyle,
			FiLeft,
			FiTop,
			FiWidth,
			FiHeight,
			Handle,    //eEBhE
			0,
			0,
			nil
		);
	end;

	//ő͕
	SendMessageW(FhEditHandle, EM_EXLIMITTEXT, 0, LPARAM(-1));
	//Cxg}XNZbg
	SendMessageW(FhEditHandle, EM_SETEVENTMASK, 0, LPARAM(
		ENM_CHANGE           //EN_CHANGE ʒm𑗂܂B
		or ENM_UPDATE        //EN_UPDATE ʒm𑗂܂B
		or ENM_SCROLL        //EN_HSCROLL ʒm EN_VSCROLL 𑗂܂B
		or ENM_SCROLLEVENTS  //}EXzC[Cxgɑ΂ EN_MSGFILTER ʒm𑗂܂B
		or ENM_DRAGDROPDONE  //EN_DRAGDROPDONE ʒm𑗂܂B
		or ENM_KEYEVENTS     //L[{[hCxgɑ΂ EN_MSGFILTER ʒm𑗂܂B
		or ENM_MOUSEEVENTS   //}EXCxgɑ΂ EN_MSGFILTER ʒm𑗂܂B
		or ENM_REQUESTRESIZE //EN_REQUESTRESIZE ʒm𑗂܂B
		or ENM_SELCHANGE     //EN_SELCHANGE ʒm𑗂܂B
		or ENM_DROPFILES     //EN_DROPFILES ʒm𑗂܂B
		or ENM_PROTECTED     //EN_PROTECTED ʒm𑗂܂B
		or ENM_CORRECTTEXT   //EN_CORRECTTEXT ʒm𑗂܂B
		or ENM_LINK          //}EX|C^ CFE_LINK eLXg̏ɂA}EXCxgƂ EN_LINK ʒm𑗂܂B
	));
	//eEBhEpublishedFontvpeBĂ΂p
	if (IsPublishedProp(FParent, 'Font')) then
	begin
		FFont := TFont(GetObjectProp(FParent, 'Font'));
		FFont.OnChange := FFontChange;
	end else
	begin
		FFont := nil;
	end;
	FSetFont(FFont);
end;

destructor TMyCustomEditControl.Destroy;
begin
	DestroyWindow(FhEditHandle);
	FhEditHandle := 0;
	inherited;
end;

//------------------------------------------------------------------------------

// TCY ---
procedure TMyCustomEditControl.FSetLeft(iLeft: Integer);
begin
	FiLeft := iLeft;
	SetWindowPos(FhEditHandle, HWND_TOP, FiLeft, FiTop, FiWidth, FiHeight, SWP_NOACTIVATE or SWP_NOZORDER);
end;

procedure TMyCustomEditControl.FSetTop(iTop: Integer);
begin
	FiTop := iTop;
	SetWindowPos(FhEditHandle, HWND_TOP, FiLeft, FiTop, FiWidth, FiHeight, SWP_NOACTIVATE or SWP_NOZORDER);
end;

procedure TMyCustomEditControl.FSetWidth(iWidth: Integer);
begin
	FiWidth := iWidth;
	SetWindowPos(FhEditHandle, HWND_TOP, FiLeft, FiTop, FiWidth, FiHeight, SWP_NOACTIVATE or SWP_NOZORDER);
end;

procedure TMyCustomEditControl.FSetHeight(iHeight: Integer);
begin
	FiHeight := iHeight;
	SetWindowPos(FhEditHandle, HWND_TOP, FiLeft, FiTop, FiWidth, FiHeight, SWP_NOACTIVATE or SWP_NOZORDER);
end;

procedure TMyCustomEditControl.SetBounds(iLeft, iTop, iWidth, iHeight: Integer);
begin
	FiLeft   := iLeft;
	FiTop    := iTop;
	FiWidth  := iWidth;
	FiHeight := iHeight;
	SetWindowPos(FhEditHandle, HWND_TOP, FiLeft, FiTop, FiWidth, FiHeight, SWP_NOACTIVATE or SWP_NOZORDER);
end;

procedure TMyCustomEditControl.SetBounds(rcRect: TRect);
begin
	with rcRect do begin
		SetBounds(Left, Top, Right - Left, Bottom - Top);
	end;
end;

function TMyCustomEditControl.FGetClientRect: TRect;
begin
	GetClientRect(FhEditHandle, Result);
end;

function TMyCustomEditControl.FGetBoundsRect: TRect;
var
	lpt_Pos : TPoint;
begin
	GetWindowRect(FhEditHandle, Result);
	lpt_Pos := Point(0, 0);
	ClientToScreen(FParent.Handle, lpt_Pos);
	OffsetRect(Result, -lpt_Pos.X, -lpt_Pos.Y);
end;

//XN[
procedure TMyCustomEditControl.ScrollCaret;
begin
	SendMessageW(FhEditHandle, EM_SCROLLCARET, 0, 0);
end;

//I[gtHg̐ݒ
procedure TMyCustomEditControl.FSetAutoFont(Value: Boolean);
var
	li_Opt : Integer;
begin
	//EEĝ悤ȕƃtHgςĂ܂Ƃꍇ֑Ώ
	li_Opt := SendMessageW(FhEditHandle, EM_GETLANGOPTIONS, 0, 0);
	if (Value) then
	begin
		li_Opt := li_Opt or IMF_AUTOFONT;
	end else
	begin
		if ((li_Opt and IMF_AUTOFONT) <> 0) then
		begin
			Dec(li_Opt, IMF_AUTOFONT);
		end;
	end;
	SendMessageW(FhEditHandle, EM_SETLANGOPTIONS, 0, LPARAM(li_Opt));
end;

function TMyCustomEditControl.GetAutoFont: Boolean;
begin
	Result := (SendMessageW(FhEditHandle, EM_GETLANGOPTIONS, 0, 0) and IMF_AUTOFONT) <> 0;
end;

procedure TMyCustomEditControl.SetAutoFont(Value: Boolean);
begin
	FSetAutoFont(Value);
	BackupValue;
	RestoreValue;
end;

//tHgZbg
procedure TMyCustomEditControl.FSetFont(Value: TFont);
var
	lb_Modified: Boolean;
begin
	if (FhEditHandle <> 0) then
	begin
		lb_Modified := FGetModified;
		FFont := Value;
		if (FFont <> nil) then
		begin
			FFont.Assign(Value);
			if not(Assigned(FFont.OnChange)) then
			begin
				FFont.OnChange := FFontChange;
			end;
			SendMessageW(FhEditHandle, WM_SETFONT, WPARAM(FFont.Handle), 0);
			FFontChange(nil);
		end else
		begin
			//ftHg̃tHgZbg
			SendMessageW(FhEditHandle, WM_SETFONT, WPARAM(GetStockObject(DEFAULT_GUI_FONT)), 0);
		end;
		if not(lb_Modified) then
		begin
			FSetModified(False);
		end;
	end;
end;

//F
procedure TMyCustomEditControl.FFontChange(Sender: TObject);
//http://www.interq.or.jp/chubu/r6/masm32/tute/tute033_Jp.html
var
	lr_Info     : TCharFormatW;
	lb_Modified : Boolean;
begin
//	if (FFont.Color <> FclTextColor) then
//	begin
		lb_Modified  := FGetModified;
		FclTextColor := FFont.Color;
		FillChar(lr_Info, SizeOf(lr_Info), 0);
		lr_Info.cbSize := SizeOf(lr_Info);
		lr_Info.dwMask := CFM_COLOR;
		lr_Info.crTextColor := ColorToRGB(FclTextColor);
		SendMessageW(FhEditHandle, EM_SETCHARFORMAT, SCF_ALL, LPARAM(@lr_Info));
		if not(lb_Modified) then
		begin
			FSetModified(False);
		end;
//	end;
end;

//wiF
procedure TMyCustomEditControl.FSetColor(Value: TColor);
begin
	if (FclBkColor <> Value) then
	begin
		FclBkColor := Value;
		SendMessageW(FhEditHandle, EM_SETBKGNDCOLOR, 0, LPARAM(ColorToRGB(FclBkColor)));
	end;
end;

//ReadOnly
procedure TMyCustomEditControl.FSetReadOnly(bReadOnly: Boolean);
begin
	if (FbReadOnly <> bReadOnly) then
	begin
		FbReadOnly := bReadOnly;
		if (FbReadOnly) then
		begin
			SendMessageW(FhEditHandle, EM_SETREADONLY, 1, 0);
		end else
		begin
			SendMessageW(FhEditHandle, EM_SETREADONLY, 0, 0);
		end;
	end;
end;

//HideSelection
procedure TMyCustomEditControl.FSetHideSelection(bHide: Boolean);
var
	li_Style : Longint;
begin
	if (FbHideSelection <> bHide) then
	begin
		FbHideSelection := bHide;
		li_Style := GetWindowLongW(FhEditHandle, GWL_STYLE);
		if (FbHideSelection) then
		begin
			//IԂۂȂO
			if (LongBool(li_Style and ES_NOHIDESEL)) then Dec(li_Style, ES_NOHIDESEL);
		end else
		begin
			//IԂۂ܂܂̊O
			li_Style := li_Style or ES_NOHIDESEL;
		end;
		RecreateWnd(li_Style);
	end;
end;

//^uݒ
procedure TMyCustomEditControl.SetTabs(Tabs: array of Integer);
//̃^uZbg\
var
	i : Integer;
begin
	SetLength(FTabs, High(Tabs)+1);
	for i := 0 to High(Tabs) do
	begin
		FTabs[i] := Tabs[i] * 4;
	end;
	FSetTabStops;
end;

//^uݒ
procedure TMyCustomEditControl.FSetTabStops;
//F_Tabsɕ̃^uZbg\
begin
	SendMessageW(FhEditHandle, EM_SETTABSTOPS, High(FTabs)+1, LPARAM(@FTabs[0]));
end;

//^uݒ
procedure TMyCustomEditControl.FSetTabs(iTabStop: Longint);
//Pꕝ
begin
	SetTabs([iTabStop]);
end;

//^u擾
function TMyCustomEditControl.FGetTabs: Longint;
//߂l-1̂Ƃ̓^uʒuZbgĂ
begin
	if (High(FTabs) > 0) then
	begin
		Result := -1;
	end else
	if (High(FTabs) = 0) then
	begin
		Result := FTabs[0];
	end else
	begin
		Result := 0;
	end;
end;


//------------------------------------------------------------------------------
// Show ---
//\
procedure TMyCustomEditControl.Show;
begin
	ShowWindow(FhEditHandle, SW_SHOW);
end;

//\
procedure TMyCustomEditControl.Hide;
begin
	ShowWindow(FhEditHandle, SW_HIDE);
end;

//tH[JX邩
function TMyCustomEditControl.Focused: Boolean;
begin
	Result := (Windows.GetFocus = FhEditHandle);
end;

//tH[JXZbg
procedure TMyCustomEditControl.SetFocus;
begin
	Windows.SetFocus(FhEditHandle);
end;


//------------------------------------------------------------------------------
//eLXgԂ
function TMyCustomEditControl.FGetText: WideString;
//http://72.14.235.132/search?q=cache:5lXXXH76vWcJ:jet2.u-abel.net/program/tips/re_uni.htm+%E3%83%AA%E3%83%83%E3%83%81%E3%82%A8%E3%83%87%E3%82%A3%E3%83%83%E3%83%88+CR+LF&cd=7&hl=ja&ct=clnk&client=opera
var
	lr_Info : TGetTextEx;
	li_Len  : Integer;
	lp_Buff : PWideChar;
begin
	li_Len := (Length * 2) +2;
	FillChar(lr_Info, SizeOf(lr_Info), 0);
	lr_Info.cb       := li_Len;
	lr_Info.flags    := GT_USECRLF;
	lr_Info.codepage := 1200;
	lp_Buff := AllocMem(li_Len);
	try
		SendMessageW(FhEditHandle, EM_GETTEXTEX, WPARAM(@lr_Info), LPARAM(lp_Buff));
		Result := WideString(lp_Buff);
	finally
		FreeMem(lp_Buff);
	end;
end;

//eLXgZbg
procedure TMyCustomEditControl.FSetText(sText: WideString);
begin
	SetWindowTextW(FhEditHandle, PWideChar(sText));
end;

//J[\ʒuԂ
function TMyCustomEditControl.FGetCaretIndex: Integer;
begin
	SendMessageW(FhEditHandle, EM_GETSEL, WPARAM(@Result), 0);
end;

//J[\ʒuZbg
procedure TMyCustomEditControl.FSetCaretIndex(iIndex: Integer);
begin
	SendMessageW(FhEditHandle, EM_SETSEL, WPARAM(iIndex), LPARAM(iIndex));
end;

//I͈͂̐擪Ԃ
function TMyCustomEditControl.FGetSelStart: Integer;
begin
	Result := FGetCaretIndex;
end;

//I͈͂̐擪Zbg
procedure TMyCustomEditControl.FSetSelStart(iIndex: Integer);
var
	li_Start : Longint;
	li_End   : Longint;
begin
	li_Start := 0;
	li_End   := 0;
	SendMessageW(FhEditHandle, EM_GETSEL, WPARAM(@li_Start), LPARAM(@li_End));
	SendMessageW(FhEditHandle, EM_SETSEL, WPARAM(iIndex),    LPARAM(@li_End));
end;

//I͈͂̒Ԃ
function TMyCustomEditControl.FGetSelLength: Integer;
var
	li_Start : Longint;
	li_End   : Longint;
begin
	li_Start := 0;
	li_End   := 0;
	SendMessageW(FhEditHandle, EM_GETSEL, WPARAM(@li_Start), LPARAM(@li_End));
	Result := li_End - li_Start;
end;

//I͈͂̒Zbg
procedure TMyCustomEditControl.FSetSelLength(iCount: Integer);
var
	li_Index : Integer;
begin
	if (iCount >= 0) then
	begin
		//iCount}CiX̂ƂɍɌđIƂƂ͂Ȃ
		li_Index := CaretIndex;
		SendMessageW(FhEditHandle, EM_SETSEL, WPARAM(li_Index), LPARAM(li_Index + iCount));
	end;
end;

//IĂ邩
function TMyCustomEditControl.FGetSelected: Boolean;
begin
	Result := (FGetSelLength > 0);
end;

procedure TMyCustomEditControl.FSetSelText(sStr: WideString);
{
>SelTextݒ肷ƑIeLXgVeLXgŒu邱Ƃł܂B
>͈͑IĂȂҏWRg[SelTextݒ肷ƃJ[\ʒuɐV}ł܂B
}
begin
	if (Selected) then begin
		CutToClipboard;
	end;
	Insert(sStr);
end;

//I𕶎擾
function TMyCustomEditControl.FGetSelText: WideString;
begin
	Result := StrCopy;
end;

//ύXꂽ
function TMyCustomEditControl.FGetModified: Boolean;
begin
	Result := BOOL(SendMessageW(FhEditHandle, EM_GETMODIFY, 0, 0));
end;

procedure TMyCustomEditControl.FSetModified(Value: Boolean);
begin
	if (Value) then
	begin
		SendMessageW(FhEditHandle, EM_SETMODIFY, 1, 0);
	end else
	begin
		SendMessageW(FhEditHandle, EM_SETMODIFY, 0, 0);
	end;
end;

//Sč폜
procedure TMyCustomEditControl.Clear;
begin
	FSetText('');
end;

//Undoł邩
function TMyCustomEditControl.FGetCanUndo: Boolean;
begin
	Result := BOOL(SendMessageW(FhEditHandle, EM_CANUNDO, 0, 0));
end;

//ɖ߂߂̃obt@NA
procedure TMyCustomEditControl.ClearUndo;
begin
	SendMessageW(FhEditHandle, EM_EMPTYUNDOBUFFER, 0, 0);
end;

//http://www.river.sannet.ne.jp/yuui/richedit.html
//Undo ɖ߂
procedure TMyCustomEditControl.Undo;
begin
	SendMessageW(FhEditHandle, EM_UNDO, 0, 0);
end;

//Redoł邩
function TMyCustomEditControl.FGetCanRedo: Boolean;
begin
	Result := BOOL(SendMessageW(FhEditHandle, EM_CANREDO, 0, 0));
end;

//Redo 蒼
procedure TMyCustomEditControl.Redo;
begin
	SendMessageW(FhEditHandle, EM_REDO, 0, 0);
end;

//؂
procedure TMyCustomEditControl.CutToClipboard;
begin
	CopyToClipboard;
	ClearSelection;
end;

//Rs[
procedure TMyCustomEditControl.CopyToClipboard;
begin
	gpcStrToClipboard(StrCopy);
end;

//\t
procedure TMyCustomEditControl.PasteFromClipboard;
begin
	SendMessageW(FhEditHandle, EM_REPLACESEL, WPARAM(1), LPARAM(PWideChar(gfnsStrFromClipboard)));
end;

//폜
procedure TMyCustomEditControl.ClearSelection;
begin
	SendMessageW(FhEditHandle, EM_REPLACESEL, WPARAM(1), LPARAM(PWideChar(WideString(''))));
end;

//ׂđI
procedure TMyCustomEditControl.SelectAll;
begin
	SendMessageW(FhEditHandle, EM_SETSEL, 0, -1);
end;

//}
procedure TMyCustomEditControl.Insert(sText: WideString);
begin
	SendMessageW(FhEditHandle, EM_REPLACESEL, WPARAM(1), LPARAM(PWideChar(sText)));
end;

//\tł邩
function TMyCustomEditControl.CanPaste: Boolean;
begin
	Result := SendMessageW(FhEditHandle, EM_CANPASTE, WPARAM(CF_TEXT), 0) <> 0;
end;

//͋
function TMyCustomEditControl.Empty: Boolean;
begin
	Result := FGetText = '';
end;
{
//oCgԂ
function TMyCustomEditControl.ByteLength: Integer;
var
	lr_Info: TGetTextLengthEx;
begin
	FillChar(lr_Info, SizeOf(lr_Info), 0);
	lr_Info.flags    := GTL_USECRLF or GTL_CLOSE or GTL_NUMBYTES;
	lr_Info.codepage := 1200;
	Result := SendMessage(F_hEditHandle, EM_GETTEXTLENGTHEX, WPARAM(@lr_Info), 0);
end;
}
//Ԃ
function TMyCustomEditControl.Length: Integer;
//2ƃJEg
var
	lr_Info: TGetTextLengthEx;
begin
	FillChar(lr_Info, SizeOf(lr_Info), 0);
	lr_Info.flags    := GTL_USECRLF or GTL_CLOSE or GTL_NUMCHARS;
	lr_Info.codepage := 1200;
	Result := SendMessage(FhEditHandle, EM_GETTEXTLENGTHEX, WPARAM(@lr_Info), 0);
end;

//Rs[
function TMyCustomEditControl.StrCopy: WideString;
var
	lr_Range : TCharRange;
	li_Len   : Cardinal;
	lp_Buff  : PWideChar;
	i : Integer;
	ls_Text : WideString;
begin
	FillChar(lr_Range, SizeOf(lr_Range), 0);
	SendMessageW(FhEditHandle, EM_EXGETSEL, WPARAM(0), LPARAM(@lr_Range));
	li_Len  := (lr_Range.cpMax - lr_Range.cpMin + 1) * 2;
	lp_Buff := AllocMem(li_Len);
	try
		SendMessageW(FhEditHandle, EM_GETSELTEXT, 0, LPARAM(lp_Buff));
		ls_Text := WideString(lp_Buff);
	finally
		FreeMem(lp_Buff);
	end;

	//sR[hCR݂̂CR+LFɂ
	Result := '';
	for i := 1 to System.Length(ls_Text) do
	begin
		case (ls_Text[i]) of
			#$D
			:begin
				Result := Result + #$A;
			end;
			#$A
			:begin
			end;
			else
			begin
				Result := Result + ls_Text[i];
			end;
		end;
	end;
end;

function TMyCustomEditControl.StrCopy(iCount: Integer): WideString;
begin
	Result := System.Copy(FGetText, FGetSelStart +1, iCount);
end;

function TMyCustomEditControl.StrCopy(iIndex, iCount: Integer): WideString;
//iIndex0x[X
begin
	Result := System.Copy(FGetText, iIndex +1, iCount);
end;

procedure TMyCustomEditControl.Find;
begin
	if (Selected) then
	begin
		Find(SelText);
	end;
end;

procedure TMyCustomEditControl.Find(sStr: WideString);
var
	li_Len, li_Index: Integer;
begin
	li_Len := System.Length(sStr);
	li_Index := FindText(sStr);
	if (li_Index > -1) then
	begin
		CaretIndex := li_Index;
		SelLength  := li_Len;
	end else
	begin
		SysUtils.Beep;
	end;
end;

function TMyCustomEditControl.FindText(sStr: WideString): Integer;
//http://yokohama.cool.ne.jp/chokuto/urawaza/message/EM_FINDTEXT.html
var
	li_Opt      : WPARAM;
	lr_FindText : TFindTextW;
begin
	FillChar(lr_FindText, SizeOf(lr_FindText), 0);
	lr_FindText.lpstrText := PWideChar(sStr);
	li_Opt := 0;

	//̕
	if (FbFindForward) then
	begin
		//ɌČ
		li_Opt := li_Opt or FR_DOWN;
		lr_FindText.chrg.cpMin := SelStart + SelLength;
		lr_FindText.chrg.cpMax := -1;
	end else
	begin
		//ɌČ
		//cpMin͈͌͂̍Ō̕AcpMax͍ŏ̕w肷
		lr_FindText.chrg.cpMin := SelStart; //Jn
		lr_FindText.chrg.cpMax := 0;        //I
	end;

	//Pꌟ
	if (FbFindWholeWord) then
	begin
		li_Opt := li_Opt or FR_WHOLEWORD;
	end;
	//IgnoreCase͑啶ʂȂAFR_MATCHCASE͎w肷Ƌʂ
	//Ȃ̂not(F_bFindIgnoreCase)FR_MATCHCASEw
	if not(FbFindIgnoreCase) then
	begin
		li_Opt := li_Opt or FR_MATCHCASE;
	end;

	Result := SendMessageW(FhEditHandle, EM_FINDTEXT, li_Opt, LPARAM(@lr_FindText));
end;

procedure TMyCustomEditControl.SaveToFile(sFile: WideString);
begin
	gpcFileWriteText(sFile, FGetText);
	FSetModified(False);
end;

procedure TMyCustomEditControl.LoadFromFile(sFile: WideString);
begin
	FSetText(gfnsFileReadText(sFile));
end;


//==============================================================================
{ TMyMemoControl }
constructor TMyMemoControl.Create(winParent: TWinControl);
begin
	FParent      := winParent;
	FScrollBars  := ssBoth; //
	FbLineHeight := False;  //sԂJȂ
	FbWordWrap   := False;  //܂Ԃ
	Tabs         := 0;      //ftHg(8)
	CreateWnd(WS_HSCROLL or WS_VSCROLL or ES_AUTOVSCROLL or ES_AUTOHSCROLL);
end;

constructor TMyMemoControl.Create(winParent: TWinControl; iStyle: DWORD);
begin
	//eEBhE
	FParent := winParent;
	//܂Ԃ
	FbWordWrap := not(LongBool(iStyle and ES_AUTOHSCROLL));
	//XN[o[
	if (LongBool(iStyle and WS_HSCROLL)) or (LongBool(iStyle and WS_VSCROLL)) then
	begin
		if not(LongBool(iStyle and WS_HSCROLL)) then
		begin
			FScrollBars := ssVertical;
		end else
		if not(LongBool(iStyle and WS_VSCROLL)) then
		begin
			FScrollBars := ssHorizontal;
		end else
		begin
			FScrollBars := ssBoth;
		end;
	end else
	begin
		FScrollBars := ssNone;
	end;
	CreateWnd(iStyle);
end;

procedure TMyMemoControl.CreateWnd(iStyle: Longint);
begin
	if (High(FTabs) < 0) then
	begin
		SetLength(FTabs, 1);
		FTabs[0] := 8 * 4;
	end;

	//XN[o[̃Zbg
	case FScrollBars of
		ssNone
		:begin	      //XN[o[Ȃ
			if (LongBool(iStyle and WS_VSCROLL)) then
			begin
				Dec(iStyle, WS_VSCROLL);
			end;
			if (LongBool(iStyle and WS_HSCROLL)) then
			begin
				Dec(iStyle, WS_HSCROLL);
			end;
		end;
		ssHorizontal
		:begin
			//[ɂXN[o[t
			//XN[o[͂Ȃ
			iStyle := iStyle or WS_HSCROLL;
			if (LongBool(iStyle and WS_VSCROLL)) then
			begin
				Dec(iStyle, WS_VSCROLL);
			end;
		end;
		ssVertical
		:begin
			//E[ɂXN[o[t
			//XN[o[͂Ȃ
			if (LongBool(iStyle and WS_HSCROLL)) then
			begin
				Dec(iStyle, WS_HSCROLL);
			end;
			iStyle := iStyle or WS_VSCROLL;
		end;
		ssBoth
		:begin
			//[ƉE[̗ɃXN[o[t
			iStyle := iStyle or WS_HSCROLL;
			iStyle := iStyle or WS_VSCROLL;
		end;
	end;
	if (FbWordWrap) and (LongBool(iStyle and WS_HSCROLL)) then
	begin
		Dec(iStyle, WS_HSCROLL);
	end;
	//TMyCustomEditControl.CreateĂł
	inherited Create(FParent, ES_MULTILINE or ES_WANTRETURN or $8000{ES_WANTTAB} or iStyle);
end;

//ޔݒl߂
procedure TMyMemoControl.RestoreValue;
begin
	FSetLineHeight; //sԂ̕
	inherited RestoreValue;
end;

//XN[o[̕ύX
procedure TMyMemoControl.SetScrollBars(Value: TScrollStyle);
var
	li_Style: Longint;
begin
	if (FScrollBars <> Value) then
	begin
		li_Style    := GetWindowLongW(Handle, GWL_STYLE);
		FScrollBars := Value;
		case FScrollBars of
			ssNone
			:begin
				//XN[o[Ȃ
				if (LongBool(li_Style and WS_VSCROLL)) then
				begin
					Dec(li_Style, WS_VSCROLL);
				end;
				if (LongBool(li_Style and WS_HSCROLL)) then
				begin
					Dec(li_Style, WS_HSCROLL);
				end;
			end;
			ssHorizontal
			:begin
				//[ɂXN[o[t
				li_Style := li_Style or WS_HSCROLL;
				//XN[o[͂Ȃ
				if (LongBool(li_Style and WS_VSCROLL)) then
				begin
					Dec(li_Style, WS_VSCROLL);
				end;
			end;
			ssVertical
			:begin
				//E[ɂXN[o[t
				//XN[o[͂Ȃ
				if (LongBool(li_Style and WS_HSCROLL)) then
				begin
					Dec(li_Style, WS_HSCROLL);
				end;
				li_Style := li_Style or WS_VSCROLL;
			end;
			ssBoth
			:begin
				//[ƉE[̗ɃXN[o[t
				li_Style := li_Style or WS_HSCROLL;
				li_Style := li_Style or WS_VSCROLL;
			end;
		end;
		RecreateWnd(li_Style);
	end;
end;

//E[Ő܂Ԃ
procedure TMyMemoControl.SetWordWrap(Value: Boolean);
var
	li_Style: Longint;
begin
	if (FbWordWrap <> Value) then
	begin
		li_Style   := GetWindowLongW(Handle, GWL_STYLE);
		FbWordWrap := Value;
		if (FbWordWrap) then
		begin
			//܂Ԃ
			if (LongBool(li_Style and ES_AUTOHSCROLL)) then
			begin
				Dec(li_Style, ES_AUTOHSCROLL);
			end;
			if (FScrollBars = ssBoth) or (FScrollBars = ssHorizontal) then
			begin
				//XN[o[oĂB
				if (LongBool(li_Style and WS_HSCROLL)) then
				begin
					Dec(li_Style, WS_HSCROLL);
				end;
			end;
		end else
		begin
			//܂ԂȂ
			li_Style := li_Style or ES_AUTOHSCROLL;
			if (FScrollBars = ssBoth) or (FScrollBars = ssHorizontal) then
			begin
				//XN[o[oݒło
				li_Style := li_Style or WS_HSCROLL;
			end;
		end;
		if (FScrollBars = ssBoth) or (FScrollBars = ssVertical) then
		begin
			//ǂݍłȂꍇȉ̓li_StyleɃZbgĂȂ̂ŃZbg
			li_Style := li_Style or ES_AUTOVSCROLL or WS_VSCROLL;
		end;
		RecreateWnd(li_Style);
	end;
end;

//sԂ̕ύX
procedure TMyMemoControl.FSetLineHeight;
var
	li_Opt : Integer;
begin
//http://hpcgi1.nifty.com/MADIA/DelphiBBS/wwwlng.cgi?print+200904/09040031.txt
	li_Opt := SendMessageW(Handle, EM_GETLANGOPTIONS, 0, 0);
	if (FbLineHeight) then
	begin
		//sԂJ
		if ((li_Opt and IMF_UIFONTS) <> 0) then
		begin
			Dec(li_Opt, IMF_UIFONTS);
		end;
	end else
	begin
		//MemoƓsԂɂ
		li_Opt := li_Opt or IMF_UIFONTS;
	end;
	SendMessageW(Handle, EM_SETLANGOPTIONS, 0, LPARAM(li_Opt));
end;

procedure TMyMemoControl.SetLineHeight(Value: Boolean);
begin
//http://hpcgi1.nifty.com/MADIA/DelphiBBS/wwwlng.cgi?print+200904/09040031.txt
	if (FbLineHeight <> Value) then
	begin
		FbLineHeight := Value;
		BackupValue;
		RestoreValue; //̒ōsԂ̃ZbgsĂ
	end;
end;

function TMyMemoControl.FGetCount: Integer;
//sԂ
begin
	Result := SendMessageW(Handle, EM_GETLINECOUNT, 0, 0);
end;

function TMyMemoControl.FGetCurrentLine: Integer;
//J[\̂sԂB
//ŏ̍s0B
begin
	Result := SendMessageW(Handle, EM_LINEFROMCHAR, WPARAM(-1), 0);
end;

function TMyMemoControl.FGetColumn: Integer;
//J[\̈ʒus̕ŕԂB
//J[\sɂƂ0ԂB
begin
	Result := CaretIndex - SendMessageW(Handle, EM_LINEINDEX, -1, 0);
end;

function TMyMemoControl.GetLine(iIndex: Integer): WideString;
//iIndexs̕ԂB
var
	lp_Buff: PWideChar;
	li_Head, li_Len: Integer;
begin
	iIndex  := gfniNumLimit(iIndex, -1, FGetCount-1);	//F_GetCount1x[X̍sAiIndex0x[X̃CfbNXȂ̂-1
	//iIndexs̓̕CfbNX擾
	li_Head := SendMessageW(Handle, EM_LINEINDEX, WPARAM(iIndex), 0);
	//iIndex݂̃J[\ʒul(-1)̏ꍇEM_GETLINEł͂܂Ȃ̂ŃJ[\s̃CfbNX擾
	if (iIndex = -1) then
	begin
		iIndex := SendMessageW(Handle, EM_LINEFROMCHAR, WPARAM(li_Head), 0);
	end;
	//擾s̕擾
	li_Len  := SendMessageW(Handle, EM_LINELENGTH, WPARAM(li_Head), 0);
	lp_Buff := AllocMem((li_Len +1) * 2);
	try
		lp_Buff[0] := WideChar(li_Len);
		SendMessageW(Handle, EM_GETLINE, WPARAM(iIndex), LPARAM(lp_Buff));
		Result := WideString(lp_Buff);
	finally
		FreeMem(lp_Buff);
	end;
end;

function TMyMemoControl.Empty: Boolean;
begin
	//SendMessageW(Handle, EM_GETLINECOUNT, 0, 0)1ɂȂ邱Ƃ͂Ȃ
	if (SendMessageW(Handle, EM_GETLINECOUNT, 0, 0) > 1) then
	begin
		Result := False;
	end else
	if (Text <> '') then
	begin
		Result := False;
	end else
	begin
		Result := True;
	end;
end;

function TMyMemoControl.StrCopy(iCount: Integer): WideString;
begin
	Result := StrCopy(FGetCurrentLine, FGetColumn, iCount);
end;

function TMyMemoControl.StrCopy(iLine, iIndex, iCount: Integer): WideString;
{
iLinesiIndexiCountRs[ĕԂB
iLine, iIndex0x[XB
CurrentLineColumnƕp₷B
}
var
	ls_Str: WideString;
begin
	ls_Str := GetLine(iLine);
	Result := System.Copy(ls_Str, iIndex +1, iCount);
end;

function TMyMemoControl.FGetTopIndex: Integer;
{
Ăԍŏ̍s̃CfbNXԂB
http://yokohama.cool.ne.jp/chokuto/urawaza/message/EM_GETFIRSTVISIBLELINE.html
}
begin
	Result := SendMessageW(Handle, EM_GETFIRSTVISIBLELINE, 0, 0);
end;

procedure TMyMemoControl.FSetTopIndex(iIndex: Integer);
{
͈͂̈ԍŏ̍sZbg
܂Ԃ2sɂ킽s1ł͂Ȃ2ƃJEg邱ƂɒӁB
}
var
	li_Scroll: Integer;
begin
	li_Scroll := iIndex - FGetTopIndex;
	SendMessageW(Handle, EM_LINESCROLL, 0, LPARAM(li_Scroll));
end;


//==============================================================================
initialization
	lhRichEditModule := 0;

finalization
	if (lhRichEditModule <> 0) then
	begin
		FreeLibrary(lhRichEditModule);
	end;


end.

